# tba_api_v3.model.EventInsights2017

## Load the model package
```dart
import 'package:tba_api_v3/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**averageFoulScore** | **double** | Average foul score. | 
**averageFuelPoints** | **double** | Average fuel points scored. | 
**averageFuelPointsAuto** | **double** | Average fuel points scored during auto. | 
**averageFuelPointsTeleop** | **double** | Average fuel points scored during teleop. | 
**averageHighGoals** | **double** | Average points scored in the high goal. | 
**averageHighGoalsAuto** | **double** | Average points scored in the high goal during auto. | 
**averageHighGoalsTeleop** | **double** | Average points scored in the high goal during teleop. | 
**averageLowGoals** | **double** | Average points scored in the low goal. | 
**averageLowGoalsAuto** | **double** | Average points scored in the low goal during auto. | 
**averageLowGoalsTeleop** | **double** | Average points scored in the low goal during teleop. | 
**averageMobilityPointsAuto** | **double** | Average mobility points scored during auto. | 
**averagePointsAuto** | **double** | Average points scored during auto. | 
**averagePointsTeleop** | **double** | Average points scored during teleop. | 
**averageRotorPoints** | **double** | Average rotor points scored. | 
**averageRotorPointsAuto** | **double** | Average rotor points scored during auto. | 
**averageRotorPointsTeleop** | **double** | Average rotor points scored during teleop. | 
**averageScore** | **double** | Average score. | 
**averageTakeoffPointsTeleop** | **double** | Average takeoff points scored during teleop. | 
**averageWinMargin** | **double** | Average margin of victory. | 
**averageWinScore** | **double** | Average winning score. | 
**highKpa** | **BuiltList<String>** | An array with three values, kPa scored, match key from the match with the high kPa, and the name of the match | 
**highScore** | **BuiltList<String>** | An array with three values, high score, match key from the match with the high score, and the name of the match | 
**kpaAchieved** | **BuiltList<double>** | An array with three values, number of times kPa bonus achieved, number of opportunities to bonus, and percentage. | 
**mobilityCounts** | **BuiltList<double>** | An array with three values, number of times mobility bonus achieved, number of opportunities to bonus, and percentage. | 
**rotor1Engaged** | **BuiltList<double>** | An array with three values, number of times rotor 1 engaged, number of opportunities to engage, and percentage. | 
**rotor1EngagedAuto** | **BuiltList<double>** | An array with three values, number of times rotor 1 engaged in auto, number of opportunities to engage in auto, and percentage. | 
**rotor2Engaged** | **BuiltList<double>** | An array with three values, number of times rotor 2 engaged, number of opportunities to engage, and percentage. | 
**rotor2EngagedAuto** | **BuiltList<double>** | An array with three values, number of times rotor 2 engaged in auto, number of opportunities to engage in auto, and percentage. | 
**rotor3Engaged** | **BuiltList<double>** | An array with three values, number of times rotor 3 engaged, number of opportunities to engage, and percentage. | 
**rotor4Engaged** | **BuiltList<double>** | An array with three values, number of times rotor 4 engaged, number of opportunities to engage, and percentage. | 
**takeoffCounts** | **BuiltList<double>** | An array with three values, number of times takeoff was counted, number of opportunities to takeoff, and percentage. | 
**unicornMatches** | **BuiltList<double>** | An array with three values, number of times a unicorn match (Win + kPa & Rotor Bonuses) occured, number of opportunities to have a unicorn match, and percentage. | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


