# tba_api_v3.model.EventInsights2018

## Load the model package
```dart
import 'package:tba_api_v3/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**autoQuestAchieved** | **BuiltList<double>** | An array with three values, number of times auto quest was completed, number of opportunities to complete the auto quest, and percentage. | 
**averageBoostPlayed** | **double** | Average number of boost power up scored (out of 3). | 
**averageEndgamePoints** | **double** | Average endgame points. | 
**averageForcePlayed** | **double** | Average number of force power up scored (out of 3). | 
**averageFoulScore** | **double** | Average foul score. | 
**averagePointsAuto** | **double** | Average points scored during auto. | 
**averagePointsTeleop** | **double** | Average points scored during teleop. | 
**averageRunPointsAuto** | **double** | Average mobility points scored during auto. | 
**averageScaleOwnershipPoints** | **double** | Average scale ownership points scored. | 
**averageScaleOwnershipPointsAuto** | **double** | Average scale ownership points scored during auto. | 
**averageScaleOwnershipPointsTeleop** | **double** | Average scale ownership points scored during teleop. | 
**averageScore** | **double** | Average score. | 
**averageSwitchOwnershipPoints** | **double** | Average switch ownership points scored. | 
**averageSwitchOwnershipPointsAuto** | **double** | Average switch ownership points scored during auto. | 
**averageSwitchOwnershipPointsTeleop** | **double** | Average switch ownership points scored during teleop. | 
**averageVaultPoints** | **double** | Average value points scored. | 
**averageWinMargin** | **double** | Average margin of victory. | 
**averageWinScore** | **double** | Average winning score. | 
**boostPlayedCounts** | **BuiltList<double>** | An array with three values, number of times a boost power up was played, number of opportunities to play a boost power up, and percentage. | 
**climbCounts** | **BuiltList<double>** | An array with three values, number of times a climb occurred, number of opportunities to climb, and percentage. | 
**faceTheBossAchieved** | **BuiltList<double>** | An array with three values, number of times an alliance faced the boss, number of opportunities to face the boss, and percentage. | 
**forcePlayedCounts** | **BuiltList<double>** | An array with three values, number of times a force power up was played, number of opportunities to play a force power up, and percentage. | 
**highScore** | **BuiltList<String>** | An array with three values, high score, match key from the match with the high score, and the name of the match | 
**levitatePlayedCounts** | **BuiltList<double>** | An array with three values, number of times a levitate power up was played, number of opportunities to play a levitate power up, and percentage. | 
**runCountsAuto** | **BuiltList<double>** | An array with three values, number of times a team scored mobility points in auto, number of opportunities to score mobility points in auto, and percentage. | 
**scaleNeutralPercentage** | **double** | Average scale neutral percentage. | 
**scaleNeutralPercentageAuto** | **double** | Average scale neutral percentage during auto. | 
**scaleNeutralPercentageTeleop** | **double** | Average scale neutral percentage during teleop. | 
**switchOwnedCountsAuto** | **BuiltList<double>** | An array with three values, number of times a switch was owned during auto, number of opportunities to own a switch during auto, and percentage. | 
**unicornMatches** | **BuiltList<double>** | An array with three values, number of times a unicorn match (Win + Auto Quest + Face the Boss) occurred, number of opportunities to have a unicorn match, and percentage. | 
**winningOppSwitchDenialPercentageTeleop** | **double** | Average opposing switch denail percentage for the winning alliance during teleop. | 
**winningOwnSwitchOwnershipPercentage** | **double** | Average own switch ownership percentage for the winning alliance. | 
**winningOwnSwitchOwnershipPercentageAuto** | **double** | Average own switch ownership percentage for the winning alliance during auto. | 
**winningOwnSwitchOwnershipPercentageTeleop** | **double** | Average own switch ownership percentage for the winning alliance during teleop. | 
**winningScaleOwnershipPercentage** | **double** | Average scale ownership percentage for the winning alliance. | 
**winningScaleOwnershipPercentageAuto** | **double** | Average scale ownership percentage for the winning alliance during auto. | 
**winningScaleOwnershipPercentageTeleop** | **double** | Average scale ownership percentage for the winning alliance during teleop. | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


